"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _DashboardItem = _interopRequireDefault(require("./DashboardItem"));
var _DashboardPropertyCreatedBy = _interopRequireDefault(require("./DashboardPropertyCreatedBy"));
var _DashboardPropertyUpdatedBy = _interopRequireDefault(require("./DashboardPropertyUpdatedBy"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The Dashboard model module.
 * @module model/Dashboard
 * @version 7.7.0
 */
var Dashboard = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>Dashboard</code>.
   * @alias module:model/Dashboard
   */
  function Dashboard() {
    _classCallCheck(this, Dashboard);
    Dashboard.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(Dashboard, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>Dashboard</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Dashboard} obj Optional instance to populate.
     * @return {module:model/Dashboard} The populated <code>Dashboard</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new Dashboard();
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('description')) {
          obj['description'] = _ApiClient["default"].convertToType(data['description'], 'String');
        }
        if (data.hasOwnProperty('items')) {
          obj['items'] = _ApiClient["default"].convertToType(data['items'], [_DashboardItem["default"]]);
        }
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('created_by')) {
          obj['created_by'] = _DashboardPropertyCreatedBy["default"].constructFromObject(data['created_by']);
        }
        if (data.hasOwnProperty('updated_by')) {
          obj['updated_by'] = _DashboardPropertyUpdatedBy["default"].constructFromObject(data['updated_by']);
        }
      }
      return obj;
    }
  }]);
  return Dashboard;
}();
/**
 * Dashboard identifier (UUID)
 * @member {String} id
 */
Dashboard.prototype['id'] = undefined;

/**
 * A human-readable name
 * @member {String} name
 */
Dashboard.prototype['name'] = undefined;

/**
 * A short description of the dashboard
 * @member {String} description
 */
Dashboard.prototype['description'] = undefined;

/**
 * A list of [dashboard items](#dashboard-item).
 * @member {Array.<module:model/DashboardItem>} items
 */
Dashboard.prototype['items'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
Dashboard.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
Dashboard.prototype['updated_at'] = undefined;

/**
 * @member {module:model/DashboardPropertyCreatedBy} created_by
 */
Dashboard.prototype['created_by'] = undefined;

/**
 * @member {module:model/DashboardPropertyUpdatedBy} updated_by
 */
Dashboard.prototype['updated_by'] = undefined;
var _default = Dashboard;
exports["default"] = _default;