"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _DashboardItemPropertyDataSource = _interopRequireDefault(require("./DashboardItemPropertyDataSource"));
var _DashboardItemPropertyVisualization = _interopRequireDefault(require("./DashboardItemPropertyVisualization"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The DashboardItem model module.
 * @module model/DashboardItem
 * @version 7.7.0
 */
var DashboardItem = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>DashboardItem</code>.
   * A dashboard item. Typically a data visualization like a chart.
   * @alias module:model/DashboardItem
   * @param title {String} A human-readable title for the dashboard item
   * @param subtitle {String} A human-readable subtitle for the dashboard item. Often a description of the visualization.
   * @param data_source {module:model/DashboardItemPropertyDataSource} 
   * @param visualization {module:model/DashboardItemPropertyVisualization} 
   */
  function DashboardItem(title, subtitle, data_source, visualization) {
    _classCallCheck(this, DashboardItem);
    DashboardItem.initialize(this, title, subtitle, data_source, visualization);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(DashboardItem, null, [{
    key: "initialize",
    value: function initialize(obj, title, subtitle, data_source, visualization) {
      obj['title'] = title;
      obj['subtitle'] = subtitle;
      obj['data_source'] = data_source;
      obj['visualization'] = visualization;
    }

    /**
     * Constructs a <code>DashboardItem</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/DashboardItem} obj Optional instance to populate.
     * @return {module:model/DashboardItem} The populated <code>DashboardItem</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new DashboardItem();
        if (data.hasOwnProperty('title')) {
          obj['title'] = _ApiClient["default"].convertToType(data['title'], 'String');
        }
        if (data.hasOwnProperty('subtitle')) {
          obj['subtitle'] = _ApiClient["default"].convertToType(data['subtitle'], 'String');
        }
        if (data.hasOwnProperty('data_source')) {
          obj['data_source'] = _DashboardItemPropertyDataSource["default"].constructFromObject(data['data_source']);
        }
        if (data.hasOwnProperty('visualization')) {
          obj['visualization'] = _DashboardItemPropertyVisualization["default"].constructFromObject(data['visualization']);
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
        if (data.hasOwnProperty('span')) {
          obj['span'] = _ApiClient["default"].convertToType(data['span'], 'Number');
        }
      }
      return obj;
    }
  }]);
  return DashboardItem;
}();
/**
 * A human-readable title for the dashboard item
 * @member {String} title
 */
DashboardItem.prototype['title'] = undefined;

/**
 * A human-readable subtitle for the dashboard item. Often a description of the visualization.
 * @member {String} subtitle
 */
DashboardItem.prototype['subtitle'] = undefined;

/**
 * @member {module:model/DashboardItemPropertyDataSource} data_source
 */
DashboardItem.prototype['data_source'] = undefined;

/**
 * @member {module:model/DashboardItemPropertyVisualization} visualization
 */
DashboardItem.prototype['visualization'] = undefined;

/**
 * Dashboard item identifier (UUID)
 * @member {String} id
 */
DashboardItem.prototype['id'] = undefined;

/**
 * The number of columns for the dashboard item to span. Dashboards are rendered on a 12-column grid on \"desktop\" screen sizes.
 * @member {Number} span
 * @default 4
 */
DashboardItem.prototype['span'] = 4;
var _default = DashboardItem;
exports["default"] = _default;