"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _DashboardItemPropertyVisualizationPropertyConfig = _interopRequireDefault(require("./DashboardItemPropertyVisualizationPropertyConfig"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The DashboardItemPropertyVisualization model module.
 * @module model/DashboardItemPropertyVisualization
 * @version 7.7.0
 */
var DashboardItemPropertyVisualization = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>DashboardItemPropertyVisualization</code>.
   * [An object](#visualization) which describes the data visualization to display. 
   * @alias module:model/DashboardItemPropertyVisualization
   * @param type {module:model/DashboardItemPropertyVisualization.TypeEnum} The type of visualization to display. 
   * @param config {module:model/DashboardItemPropertyVisualizationPropertyConfig} 
   */
  function DashboardItemPropertyVisualization(type, config) {
    _classCallCheck(this, DashboardItemPropertyVisualization);
    DashboardItemPropertyVisualization.initialize(this, type, config);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(DashboardItemPropertyVisualization, null, [{
    key: "initialize",
    value: function initialize(obj, type, config) {
      obj['type'] = type;
      obj['config'] = config;
    }

    /**
     * Constructs a <code>DashboardItemPropertyVisualization</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/DashboardItemPropertyVisualization} obj Optional instance to populate.
     * @return {module:model/DashboardItemPropertyVisualization} The populated <code>DashboardItemPropertyVisualization</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new DashboardItemPropertyVisualization();
        if (data.hasOwnProperty('type')) {
          obj['type'] = _ApiClient["default"].convertToType(data['type'], 'String');
        }
        if (data.hasOwnProperty('config')) {
          obj['config'] = _DashboardItemPropertyVisualizationPropertyConfig["default"].constructFromObject(data['config']);
        }
      }
      return obj;
    }
  }]);
  return DashboardItemPropertyVisualization;
}();
/**
 * The type of visualization to display. 
 * @member {module:model/DashboardItemPropertyVisualization.TypeEnum} type
 */
DashboardItemPropertyVisualization.prototype['type'] = undefined;

/**
 * @member {module:model/DashboardItemPropertyVisualizationPropertyConfig} config
 */
DashboardItemPropertyVisualization.prototype['config'] = undefined;

/**
 * Allowed values for the <code>type</code> property.
 * @enum {String}
 * @readonly
 */
DashboardItemPropertyVisualization['TypeEnum'] = {
  /**
   * value: "chart"
   * @const
   */
  "chart": "chart"
};
var _default = DashboardItemPropertyVisualization;
exports["default"] = _default;