"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _Mtdlineitems = _interopRequireDefault(require("./Mtdlineitems"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The Mtdinvoice model module.
 * @module model/Mtdinvoice
 * @version 7.7.0
 */
var Mtdinvoice = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>Mtdinvoice</code>.
   * @alias module:model/Mtdinvoice
   */
  function Mtdinvoice() {
    _classCallCheck(this, Mtdinvoice);
    Mtdinvoice.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(Mtdinvoice, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>Mtdinvoice</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Mtdinvoice} obj Optional instance to populate.
     * @return {module:model/Mtdinvoice} The populated <code>Mtdinvoice</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new Mtdinvoice();
        if (data.hasOwnProperty('customer_id')) {
          obj['customer_id'] = _ApiClient["default"].convertToType(data['customer_id'], 'String');
        }
        if (data.hasOwnProperty('invoice_id')) {
          obj['invoice_id'] = _ApiClient["default"].convertToType(data['invoice_id'], 'String');
        }
        if (data.hasOwnProperty('billing_start_date')) {
          obj['billing_start_date'] = _ApiClient["default"].convertToType(data['billing_start_date'], 'Date');
        }
        if (data.hasOwnProperty('billing_end_date')) {
          obj['billing_end_date'] = _ApiClient["default"].convertToType(data['billing_end_date'], 'Date');
        }
        if (data.hasOwnProperty('monthly_transaction_amount')) {
          obj['monthly_transaction_amount'] = _ApiClient["default"].convertToType(data['monthly_transaction_amount'], 'String');
        }
        if (data.hasOwnProperty('transaction_line_items')) {
          obj['transaction_line_items'] = _ApiClient["default"].convertToType(data['transaction_line_items'], [_Mtdlineitems["default"]]);
        }
      }
      return obj;
    }
  }]);
  return Mtdinvoice;
}();
/**
 * The Customer ID associated with the invoice.
 * @member {String} customer_id
 */
Mtdinvoice.prototype['customer_id'] = undefined;

/**
 * An alphanumeric string identifying the invoice.
 * @member {String} invoice_id
 */
Mtdinvoice.prototype['invoice_id'] = undefined;

/**
 * The date and time (in ISO 8601 format) for the initiation point of a billing cycle, signifying the start of charges for a service or subscription.
 * @member {Date} billing_start_date
 */
Mtdinvoice.prototype['billing_start_date'] = undefined;

/**
 * The date and time (in ISO 8601 format) for the termination point of a billing cycle, signifying the end of charges for a service or subscription.
 * @member {Date} billing_end_date
 */
Mtdinvoice.prototype['billing_end_date'] = undefined;

/**
 * The total billable amount for invoiced services charged within a single month.
 * @member {String} monthly_transaction_amount
 */
Mtdinvoice.prototype['monthly_transaction_amount'] = undefined;

/**
 * @member {Array.<module:model/Mtdlineitems>} transaction_line_items
 */
Mtdinvoice.prototype['transaction_line_items'] = undefined;
var _default = Mtdinvoice;
exports["default"] = _default;