"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The Serviceusagemetric model module.
 * @module model/Serviceusagemetric
 * @version 7.7.0
 */
var Serviceusagemetric = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>Serviceusagemetric</code>.
   * @alias module:model/Serviceusagemetric
   */
  function Serviceusagemetric() {
    _classCallCheck(this, Serviceusagemetric);
    Serviceusagemetric.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(Serviceusagemetric, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>Serviceusagemetric</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Serviceusagemetric} obj Optional instance to populate.
     * @return {module:model/Serviceusagemetric} The populated <code>Serviceusagemetric</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new Serviceusagemetric();
        if (data.hasOwnProperty('customer_id')) {
          obj['customer_id'] = _ApiClient["default"].convertToType(data['customer_id'], 'String');
        }
        if (data.hasOwnProperty('service_id')) {
          obj['service_id'] = _ApiClient["default"].convertToType(data['service_id'], 'String');
        }
        if (data.hasOwnProperty('service_name')) {
          obj['service_name'] = _ApiClient["default"].convertToType(data['service_name'], 'String');
        }
        if (data.hasOwnProperty('usage_units')) {
          obj['usage_units'] = _ApiClient["default"].convertToType(data['usage_units'], 'Number');
        }
      }
      return obj;
    }
  }]);
  return Serviceusagemetric;
}();
/**
 * @member {String} customer_id
 */
Serviceusagemetric.prototype['customer_id'] = undefined;

/**
 * Service ID associated with the usage.
 * @member {String} service_id
 */
Serviceusagemetric.prototype['service_id'] = undefined;

/**
 * Name of the service associated with the usage.
 * @member {String} service_name
 */
Serviceusagemetric.prototype['service_name'] = undefined;

/**
 * The quantity of the usage for the billing period. Amount will be in the units provided in the parent object (e.g., a quantity of `1.3` with a unit of `gb` would have a usage amount of 1.3 gigabytes).
 * @member {Number} usage_units
 */
Serviceusagemetric.prototype['usage_units'] = undefined;
var _default = Serviceusagemetric;
exports["default"] = _default;